<?php

require('../model/web_services.php');
require('../model/product_db_rest.php');
require('../model/category_db_rest.php');

$action = filter_input(INPUT_POST, 'action');
if ($action == NULL) {
    $action = filter_input(INPUT_GET, 'action');
    if ($action == NULL) {
        $action = 'list_products';
    }
}

if ($action == 'list_products') {
    $category_id = filter_input(INPUT_GET, 'category_id', FILTER_VALIDATE_INT);
    if ($category_id == NULL || $category_id == FALSE) {
        $category_id = 1;
    }
    try {
        $categories = get_categories();
        $category_name = get_category_name($category_id);
        $products = get_products_by_category($category_id);
    } catch (Exception $e) {
        $error_message = $e->getMessage();
        error_log("error in product catalog:" . $error_message);
        include('../errors/rest_error.php');
        exit();
    }
    include('product_list.php');
} else if ($action == 'view_product') {
    $product_id = filter_input(INPUT_GET, 'product_id', FILTER_VALIDATE_INT);
    // added for easy lookup by REST services--
    $category_id = filter_input(INPUT_GET, 'category_id', FILTER_VALIDATE_INT);
    if ($product_id == NULL || $product_id == FALSE) {
        $error = 'Missing or incorrect product id.';
        include('../errors/error.php');
    } else 
        if ($category_id == NULL || $category_id == FALSE) {
        $error = 'Missing or incorrect category id.';
        include('../errors/error.php');
    } else{
        try {
            $categories = get_categories();
            $product = get_product($product_id, $category_id);
        } catch (Exception $e) {
            $error_message = $e->getMessage();
            error_log("error in product catalog:" . $error_message);
            include('../errors/rest_error.php');
            exit();
        }
        // Get product data
        $code = $product['productCode'];
        $name = $product['productName'];
        $list_price = $product['listPrice'];

        // Calculate discounts
        $discount_percent = 30;  // 30% off for all web orders
        $discount_amount = round($list_price * ($discount_percent / 100.0), 2);
        $unit_price = $list_price - $discount_amount;

        // Format the calculations
        $discount_amount_f = number_format($discount_amount, 2);
        $unit_price_f = number_format($unit_price, 2);

        // Get image URL and alternate text
        $image_filename = '../images/' . $code . '.png';
        $image_alt = 'Image: ' . $code . '.png';

        include('product_view.php');
    }
}