<?php

//require('../model/database.php');
require('../model/web_services.php');
require('../model/product_db_rest.php');
require('../model/category_db_rest.php');

$action = filter_input(INPUT_POST, 'action');
if ($action == NULL) {
    $action = filter_input(INPUT_GET, 'action');
    if ($action == NULL) {
        $action = 'list_products';
    }
}

if ($action == 'list_products') {
    try {
        $category_id = filter_input(INPUT_GET, 'category_id', FILTER_VALIDATE_INT);
        if ($category_id == NULL || $category_id == FALSE) {
            $category_id = 1;
        }
        $category_name = get_category_name($category_id);
        $categories = get_categories();
        $products = get_products_by_category($category_id);
    } catch (Exception $e) {
        $error_message = $e->getMessage();
        echo 'error in program manager: ' . $error_message;
        error_log("error:" . $error_message);
        include('../errors/rest_error.php');
        exit();
    }
    include('product_list.php');
} else if ($action == 'delete_product') {
    $product_id = filter_input(INPUT_POST, 'product_id', FILTER_VALIDATE_INT);
    $category_id = filter_input(INPUT_POST, 'category_id', FILTER_VALIDATE_INT);
    if ($category_id == NULL || $category_id == FALSE ||
            $product_id == NULL || $product_id == FALSE) {
        $error = "Missing or incorrect product id or category id.";
        include('../errors/error.php');
    } else {
        try {
            delete_product($product_id, $category_id);
        } catch (Exception $e) {
            $error_message = $e->getMessage();
            echo 'error in program manager: ' . $error_message;
            error_log("error:" . $error_message);
            include('../errors/rest_error.php');
            exit();
        }
        header("Location: .?category_id=$category_id");
    }
} else if ($action == 'show_add_form') {
    try {
        $categories = get_categories();
    } catch (Exception $e) {
        $error_message = $e->getMessage();
        echo 'error in program manager: ' . $error_message;
        error_log("error:" . $error_message);
        include('../errors/rest_error.php');
        exit();
    }
    include('product_add.php');
} else if ($action == 'add_product') {
    $category_id = filter_input(INPUT_POST, 'category_id', FILTER_VALIDATE_INT);
    $code = filter_input(INPUT_POST, 'code');
    $name = filter_input(INPUT_POST, 'name');
    $price = filter_input(INPUT_POST, 'price', FILTER_VALIDATE_FLOAT);
    if ($category_id == NULL || $category_id == FALSE || $code == NULL ||
            $name == NULL || $price == NULL || $price == FALSE) {
        $error = "Invalid product data. Check all fields and try again.";
        include('../errors/error.php');
    } else {
        try {
            add_product($category_id, $code, $name, $price);
        } catch (Exception $e) {
            $error_message = $e->getMessage();
            error_log("error:" . $error_message);
            include('../errors/rest_error.php');
            exit();
        }
        header("Location: .?category_id=$category_id");
    }
}
?>